const system = require("../../../system");
const Dao = require("../../dao.base");
class ProductInterfaceDao extends Dao {
  constructor() {
    super(Dao.getModelName(ProductInterfaceDao));
  }
  async getListByProductPriceId(productPriceId) {
    return await this.model.findAll({
      where: {
        product_price_id: productPriceId
      },
      attributes: [
        "id",
        "interface_url",
        "method_name",
        "params",
        "interface_type",
        "interface_type_name",
        "op_type",
        "op_type_name",
        "desc"],
      raw: true
    });
  }
}
module.exports = ProductInterfaceDao;
